PHP_ARG_ENABLE(arma,           for armadillo support,
[  --enable-arma            Enable armadillo support])

PHP_ARG_ENABLE(arma-operators, for operator overloading support in armadillo,
[  --enable-arma-operators  Enable operator overloading for armadillo ], no, no)

if test "$PHP_ARMA" != "no"; then
  PHP_REQUIRE_CXX()

  ARMA_SRC="                           \
    src/php_arma.cc                    \
    src/functions.cc                   \
    src/constants.cc                   \
    src/base.cc                        \
    src/complex.cc                     \
    src/mapval.cc                      \
    src/dense.cc                       \
    src/matrix.cc                      \
    src/dense_matrix.cc                \
    src/resizable.cc                   \
    src/resizable_matrix.cc            \
    src/dense_resizable_matrix.cc      \
    src/mat.cc
  "

  if test "$PHP_ARMA_OPERATORS" != "no"; then
    AC_DEFINE(PHP_ARMA_OPERATORS, 1, [ Defined if operator overloading is enabled for armadillo. ])
    ARMA_SRC+="src/operators.cc"
  fi

  PHP_NEW_EXTENSION(arma, $ARMA_SRC, $ext_shared, , -std=c++17)

  PHP_ADD_LIBRARY(armadillo, 1, ARMA_SHARED_LIBADD)
  PHP_SUBST(ARMA_SHARED_LIBADD)
fi
