//
// php-armadillo/matrix.cc
//
// @Author CismonX
//

#include "matrix.hh"
#include "mat.hh"

#include <armadillo>

namespace php_arma
{
    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, nRows, T, T1)
    {
        auto native = THIS_NATIVE;
        RETVAL_LONG(native->n_rows);
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, nCols, T, T1)
    {
        auto native = THIS_NATIVE;
        RETVAL_LONG(native->n_cols);
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, isVec, T, T1)
    {
        auto native = THIS_NATIVE;
        RETVAL_BOOL(native->is_vec());
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, isCol, T, T1)
    {
        auto native = THIS_NATIVE;
        RETVAL_BOOL(native->is_colvec());
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, isRow, T, T1)
    {
        auto native = THIS_NATIVE;
        RETVAL_BOOL(native->is_rowvec());
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, isSquare, T, T1)
    {
        auto native = THIS_NATIVE;
        RETVAL_BOOL(native->is_square());
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, isHermitian, T, T1)
    {
        
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, isSympd, T, T1)
    {
        
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, inRange, T, T1)
    {
        
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, swapRows, T, T1)
    {
        
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, swapCols, T, T1)
    {
        
    }

    template <typename T, typename T1>
    PHP_ARMA_METHOD(matrix, t, T, T1)
    {
        
    }

    template <typename T, typename T1>
    PHP_ARMA_START_ME(matrix, T, T1)
        PHP_ARMA_ME(nRows,       ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(nCols,       ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(isVec,       ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(isCol,       ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(isRow,       ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(isSquare,    ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(isHermitian, ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(isSympd,     ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(inRange,     ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(swapRows,    ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(swapCols,    ZEND_ACC_PUBLIC)
        PHP_ARMA_ME(t,           ZEND_ACC_PUBLIC)
    PHP_ARMA_END_ME();

    void matrix_init()
    {
        matrix_ce = interface_register<matrix_php_name>();
    }

    PHP_ARMA_INSTANTIATE(matrix, mat);
}
