//
// php-armadillo/stream_utils.hh
//
// @Author CismonX
//

#ifndef PHP_ARMA_STREAM_UTILS_HH
#define PHP_ARMA_STREAM_UTILS_HH

#include "php_arma.hh"

#ifdef __GNUC__
#include <ext/stdio_filebuf.h>
#endif // __GNUC__

namespace php_arma
{
#ifdef __GNUC__
    zend_always_inline
    int zval_to_fd(zval *zv)
    {
        auto stream = reinterpret_cast<php_stream*>(zend_fetch_resource2_ex(
            zv, "stream", php_file_le_stream(), php_file_le_pstream()));
        if (stream == nullptr) {
            return -1;
        }
        struct {
            FILE *file;
            int   fd;
        } *stream_data = reinterpret_cast<decltype(stream_data)>(stream->abstract);
        return stream_data->fd;
    }
#else
    zend_always_inline
    void filebuf_unsupported()
    {
        zend_throw_exception(zend_ce_type_error, "Resource is not yet supported. Use file name instead, "
            "or re-compile php-armadillo with a compiler supporting GNU extensions.", 0);
    }
#endif // __GNUC__
}

#endif // !PHP_ARMA_STREAM_UTILS_HH
