<?php

/**
 * Print message if test fail.
 *
 * @param string $test
 * @param array $cases
 * @return bool
 */
function batch_assert($test, ...$cases) {
    foreach ($cases as $case) {
        [$expected, $got] = $case;
        if ($expected == $got) {
            continue;
        }
        echo "Test for $test failed.\n";
        $expected = var_export($expected, true);
        $got      = var_export($got,      true);
        echo "Expected:\n$expected\n";
        echo "Got:\n$got\n";
        return false;
    }
    return true;
}
